/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var usespopup;
var doc;
var created=false;

var gLifeTime=2;
var abURI=null;
var ioService=Components.classes["@mozilla.org/network/io-service;1"]
               .getService(Components.interfaces.nsIIOService);

var mabFiles;
var mabName;
var mabFile;
var oldRemoteFileName;
var warn=0;

var strings;
var syncing;

var cleanUp=null;
var gAbort=false;

//TODO: welche Addressbcher sind auf dem Server zu finden!?
function download()
{
  usespopup=window.location=='chrome://addressbookssync/content/download.xul';

  strings = document.getElementById("strings");

  var synctype='none';
  doc=usespopup?window.opener.document:document;
  if (doc.getElementById("UseMabFile") && doc.getElementById( "UseMabFile" ).value) {
    mabFiles=new Array(doc.getElementById("UseMabFile").value);
    doc.getElementById("UseMabFile").value='';
    synctype='remote';
    syncing=false;
    created=doc.getElementById("MabCreated").checked;
    doc.getElementById("MabCreated").checked=false;
  } else {
    mabFiles=syncedAddressbooks();
    try{ synctype = pref.getCharPref( "extensions.addressbookssync.synctype" ); }
      catch(e){ synctype = 'none'; }
    syncing=true;
  }

  if (synctype=='local') {
    gTempName='abstemp.mab';
    setTimeout(getLocalData, 0);  // need time to show the popup
  } else if (synctype=='remote') {
    gTempName='abstemp.mab';
    abURI=getSyncURI(false);
    oldRemoteFileName='';
    setTimeout(getData, 0);
  } else if (synctype=='imap') {
    setTimeout(imapLoad, 0);
  } else {
    killMe();
  }
}

function getLocalData() {
  var localpath=pref.getCharPref( "extensions.addressbookssync.localpath" )
  if (localpath) {
    var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    dir.initWithPath( localpath );
    for (var i = 0; i < mabFiles.length; i++) {
      if (gAbort) break;
      var mabFile=mabFiles[i];
      var cur=getAddressBook(mabFile);
      var mabName=cur.directoryProperties.description;
      var uri = cur.directoryProperties.URI;

      var localFileName;
      var oldLocalFileName;
      if (!syncing || uri!=kPersonalAddressbookURI && uri!=kCollectedAddressbookURI) {
        localFileName = mabName+'.mab'; //ex: =mabFile
        oldLocalFileName = localFileName==mabFile?'':mabFile;
      } else {
        localFileName = '_tb_'+cur.directoryProperties.fileName;
        oldLocalFileName = mabFile;
      }

      if (loadMabFile(mabName, mabFile, dir, localFileName, oldLocalFileName))
        statustxt(mabName+': '+strings.getString('ok'), true, false);
      else
        statustxt(mabName+': '+strings.getString('failed'), true, true);
    }
  }
  killMe();
}

function getData()
{
  if (gAbort) {
    killMe();
    return;
  }
  if (!oldRemoteFileName) {
    mabFile=mabFiles.pop();
    if (!mabFile) {
      if (warn) gLifeTime=5;//a little bit longer
      killMe();
      return;
    }
    var cur=getAddressBook(mabFile);
    mabName=cur.directoryProperties.description;
    var uri = cur.directoryProperties.URI;

    var remoteFileName;
    if (!syncing || uri!=kPersonalAddressbookURI && uri!=kCollectedAddressbookURI) {
      remoteFileName = mabName+".mab";
      oldRemoteFileName='';
    } else {
      remoteFileName = '_tb_'+cur.directoryProperties.fileName;
      oldRemoteFileName=mabName+".mab";
    }
    statustxt("download "+mabName+".", true, false);  // 1. dot: start
  } else {
    remoteFileName=oldRemoteFileName;
    oldRemoteFileName = '';
  }

  var mabURI=abURI+remoteFileName;
  var URI=ioService.newURI(mabURI,null,null);

  statustxt(".", false, false); // 2. dot: start of download

  if(gBookmarksSynchronizerDownloadService.start(URI, downloadCallback))
    statustxt(".", false, false); // 3. dot: download started
  else
    downloadCallback("done",-1);
}

function downloadCallback(aStatus,aError)
{
  if(aStatus != "done" && aError==0)
    return;

  switch(aError){
    case -2:
      return;
      break;
    case 0:
      var time=gBookmarksSynchronizerDownloadService.time;    //download time
      var processtime=gBookmarksSynchronizerDownloadService.length.toString()
                        +" bytes  "+(time/1000).toString() + " sec  ";
      var start=new Date();
      statustxt(".", false, false); // 4. dot: download complete
      try{
        var abData=gBookmarksSynchronizerDownloadService.data;
        //Data must start with: // <!-- <mdb:mork:z v="1.4"/> --> otherwise its an HTML error page
        if (abData.substr( 0, 19 )=='// <!-- <mdb:mork:z') {
          oldRemoteFileName=''; // stop retry loop

          var nsITmpFile = getDir('TmpD');
          nsITmpFile.appendRelativePath( gTempName );
          writeMabData(nsITmpFile, abData);
          statustxt(".", false, false); // 5. dot: file written
          replaceAddressBook(mabName, mabFile, nsITmpFile);
          var end=new Date();
          processtime += ((end.getTime() - start.getTime())/1000).toString()+" sec";  //processing time
          statustxt(strings.getString('ok')+' '+processtime, false, false);
          if (created) {
            doc.init(true); // update options list, if necessary
            created=false;
          }
        } else {    //try to extract error message from <title> tag
          if (!oldRemoteFileName) { // probably check for '404'
            if(abData.match(/<title>(.+)<\/title>/i))
              statustxt(RegExp.$1, false, true);
            else
              statustxt(strings.getString('failed'), false, true);
            warn=1;
          }
        }
      } catch(e) {
        if(e && e.toString().match(/^absync\:(.+)$/))
          statustxt(RegExp.$1, false, true);
      }
      break;
    default:
      //0x804b0016 is FTPs 'no such file'
      if (aError!=0x804b0016 || !oldRemoteFileName) {
        var error=errorstr(aError);
        statustxt(error, false, true);
  //      gLifeTime=5;
  //      killMe();
      }
      break;
  }
  if (created) {
    // if created is true, we alread had created a new addressbook
    // (in Download.mab() in options.js ) but the download failed
    deleteAddressBook(mabName, mabFile);
  }
  if (usespopup) getData();  // next addressbook
  else setTimeout(getData, 1000);
}

function cancelDownload()
{
  //gBookmarksSynchronizerDownloadService.cancel(); //No, or we may left behind with corrupt mabs
  gAbort=true;
}

function killMe()
{
  if (cleanUp) {
    cleanUp();
    cleanUp=null;
  }
  if (gTempName && !gAbort) {
    if (!deleteTempFile(gTempName)) {
      setTimeout(killMe,1000);
      return;
    } else
    gTempName='';
  }
  if (gAbort) {
    statustxt(strings.getString('aborted'), true, false);
    gAbort=false;
  }
  if(gLifeTime>0 && usespopup) {
    gLifeTime--;
    setTimeout(killMe,1000);
  } else {
    var observerService = Components.classes["@mozilla.org/observer-service;1"]
      .getService(Components.interfaces.nsIObserverService);
    observerService.notifyObservers(null,"addressbookssync:download",'finish');
    statustxt('', true, false);
    if (usespopup) setTimeout(close,0);
  }
}


